----------------------------------------------------------------------------
----------------------------------------------------------------------------
--                                                                        --
--     DSA 2 Exercise 1 (ex2)                                             --
--     Program Title : ListPackage Version 0.9                            --
--     Author : John Urquhart Ferguson                                    --
--     Group : L                                                          --
--     Matriculation Number : 0102662                                     --
--     Date Last Modified : 15th December 2003                            --
--                                                                        --
--     Description : This package contains functions and procedures for   --
--                   storing and manipulating large integers              --
--                                                                        --
--                                                                        --
--     State of Program: The program has worked correctly for all test    --
--                       data.                                            --
--                                                                        --
----------------------------------------------------------------------------
----------------------------------------------------------------------------

with Ada.Integer_Text_Io; use Ada.Integer_Text_Io;
with Ada.Text_Io; use Ada.Text_Io;
package body ListPackage is
   
   ----------------------------------------------------------------
   ----------------------------------------------------------------
   function Add(X,Y:Big) return Big is
   -- Calculates x+y and returns as type big
      X_Temp : Big;
      Y_Temp : Big;
      R      : Big;
      R_Temp : Big;
      C, S, P, Q   : Integer;      
   begin
      
      -- Clear variables of data
      C := 0;
      S := 0;
      P := 0;
      Q := 0;
      R_Temp.Head := null;
      R_Temp.Tail := null;
      R.Head := null;
      R.Tail := null;
      
      -- Assign X and Y to worker variables
      X_Temp := X;
      Y_Temp := Y;
      
      -- If X or Y have no values, return R (which will = null)
      if (X.Head /= null) or (Y.Head /= null) then
         
         -- If there is still data in the current X_Temp or Y_Temp or there
         -- is a carry, get intermediate values for use in equations
         while (X_Temp.Head /= null) or (Y_Temp.Head /= null) or (C = 1) loop
            if (X_Temp.Head = null) and (Y_Temp.Head /= null) then
               Q := Y_Temp.Head.all.Val;
               Y_Temp.Head := Y_Temp.Head.all.Next;
               P := 0;
            elsif (X_Temp.Head /= null) and (Y_Temp.Head = null) then
               P := X_Temp.Head.all.Val;
               X_Temp.Head := X_Temp.Head.all.Next;
               Q := 0;
            elsif (X_Temp.Head = null) and (Y_Temp.Head =null) then
               P := 0;
               Q := 0;
            else
               P := X_Temp.Head.all.Val;
               X_Temp.Head := X_Temp.Head.all.Next;
               Q := Y_Temp.Head.all.Val;
               Y_Temp.Head := Y_Temp.Head.all.Next;
            end if;
            
            -- Use intermediate values to calculate sum and carry
            if R.Head = null then
               S:= (P + Q) rem 1000;
               C:= (P + Q) / 1000;
            else
               S:= (P + Q + C) rem 1000;
               C:= (P + Q + C) / 1000;
            end if;
            
            -- Add new nodes containing correct values
            -- to doubly linked list
            if R.Head = null then
               R.Head := new N'(null, null, S);               
               R.Tail := R.Head;
            else
               R.Tail.all.Next := new N'(null, null, S);
               R_Temp := R;
               R.Tail := R.Tail.all.Next;
               R.Tail.all.Prev := R_Temp.Tail;               
            end if;
         end loop;
         
      end if;
      return R;
   end Add;
   ----------------------------------------------------------------
   ----------------------------------------------------------------


   ----------------------------------------------------------------
   ----------------------------------------------------------------
   function IsEqual(x,y:Big) return Boolean is
   -- Returns the boolean expression x=y
      X_Temp : Big;
      Y_Temp : Big;
   begin
      
      -- Assign X and Y to worker variables
      X_Temp := X;
      Y_Temp := Y;
      
      -- Test all possible cases in which X = Y (or X /= Y)
      -- using recursion to call all nodes.
      if (X_Temp.Head /= null) and (Y_Temp.Head /= null) then
         if (X_Temp.Head.all.Val = Y_Temp.Head.all.Val) then
            X_Temp.Head := X_Temp.Head.all.Next;
            Y_Temp.Head := Y_Temp.Head.all.Next;
            return Isequal(X_Temp, Y_Temp);
         else
            return False;
         end if;
      elsif (X_Temp.Head /= null) and (Y_Temp.Head = null) then
         return False;
      elsif (X_Temp.Head = null) and (Y_Temp.Head /= null) then
         return False;
      elsif (X_Temp.Head = null) and (Y_Temp.Head = null) then
         return True;
      else
         return False;
      end if;

   end IsEqual;
   ----------------------------------------------------------------
   ----------------------------------------------------------------
   

   ----------------------------------------------------------------
   ----------------------------------------------------------------
   procedure MakeOne(One: out Big) is
   -- Make the value 1 of type Big      
      One_L : Big_L;
   begin      
      One_L := null;
      One_L := new N;
      One_L.all.Val := 1;
      One_L.all.Next := null;
      One_L.all.Prev := null;
      One.Head := One_L;
      One.Tail := One_L;               
   end Makeone;
   ----------------------------------------------------------------
   ----------------------------------------------------------------
   

   ----------------------------------------------------------------
   ----------------------------------------------------------------
   procedure MakeZero(One: out Big) is
   -- Make the value 0 of type Big
   -- This is required for the helpFib function to work      
      One_L : Big_L;
   begin      
      One_L := null;
      One_L := new N;
      One_L.all.Val := 0;
      One_L.all.Next := null;
      One_L.all.Prev := null;
      One.Head := One_L;
      One.Tail := One_L;               
   end MakeZero;
   ----------------------------------------------------------------
   ----------------------------------------------------------------
   

   ----------------------------------------------------------------
   ----------------------------------------------------------------
   procedure WriteBig(x:Big) is
   -- Writes the value of x to standard output
      X_Temp : Big;
   begin
      
      -- Assign X to a worker variable
      X_Temp := X;
      if X.Tail /= null then
         if X.Tail.all.Next /=null then
            if X.Tail.all.Val < 100 then
               if X.Tail.all.Val < 10 then
                  Put ("00");
               else
                  Put ("0");
               end if;
            end if;
         end if;
         
         -- Output current node value then
         -- recursively call other node values
         -- for output.
         Put (X.Tail.all.Val,1);
         X_Temp.Tail := X_Temp.Tail.all.Prev; 
         WriteBig(X_Temp); 
      end if;
   end WriteBig;
   ----------------------------------------------------------------
   ----------------------------------------------------------------

end ListPackage;
