----------------------------------------------------------------------------
----------------------------------------------------------------------------
--                                                                        --
--     DSA 2 Exercise 1 (ex2)                                             --
--     Program Title : ListPackage Version 0.9                            --
--     Author : John Urquhart Ferguson                                    --
--     Group : L                                                          --
--     Matriculation Number : 0102662                                     --
--     Date Last Modified : 15th December 2003                            --
--                                                                        --
--     Description : This package contains functions and procedures for   --
--                   storing and manipulating large integers              --
--                                                                        --
--                                                                        --
--     State of Program: The program has worked correctly for all test    --
--                       data.                                            --
--                                                                        --
----------------------------------------------------------------------------
----------------------------------------------------------------------------

package ListPackage is
   
   -- Type Big contains large integer values
   type Big is private;
   
   function Add(x,y:Big) return Big;
   -- Calculates x+y and returns as type big
   
   function IsEqual(x,y:Big) return Boolean;
   -- Returns the boolean expression x=y
   
   procedure MakeOne(One: out Big);
   -- Make the value 1 of type Big
   
   procedure MakeZero(One: out Big);
   -- Make the value 1 of type Big
   
   procedure WriteBig(x:Big);
   -- Writes the value of x
   
private
      
   -- Type big is stored as a record of
   -- linked lists so that, in theory, it 
   -- will never have an integer so large
   -- that it cannot be stored in Big.
   type N;
   type Big_L is access N;
   type N is
      record
         Next : Big_L;
         Prev : Big_L;
         Val  : Integer;
   end record;
   
   type Big is
      record
         Head : Big_L;
         Tail : Big_L;
   end record;
      
end ListPackage;